# std::type_info::operator==, std::type_info::operator!=

From cppreference.com
< cpp‎ | types‎ | type info

bool operator==( const type_info& rhs ) const; |  |
bool operator!=( const type_info& rhs ) const; |  |

Checks if the objects refer to the same types.

### Parameters

rhs | - | another type information object to compare to

### Return value

true if the comparison operation holds true, false otherwise

### Example

Run this code

    #include <iostream>
    #include <typeinfo>
    #include <string>
    #include <utility>

    class person
    {
      public:

       person(std::string&& n) : _name(n) {}
       virtual const std::string& name() const{ return _name; }

      private:

        std::string _name;
    };

    class employee : public person
    {
       public:

         employee(std::string&& n, std::string&& p) :
             person(std::move(n)), _profession(std::move(p)) {}

         const std::string& profession() const { return _profession; }

       private:

         std::string _profession;
    };

    void somefunc(const person& p)
    {
       if(typeid(employee) == typeid(p))
       {
          std::cout << p.name() << " is an employee ";
          auto& emp = dynamic_cast<const employee&>(p);
          std::cout << "who works in " << emp.profession() << '\n';
       }
    }

    int main()
    {
       employee paul("Paul","Economics");
       somefunc(paul);
    }

Output:

    Paul is an employee who works in Economics

### See also

before | checks whether the referred type precedes referred type of another `type_index` object in the implementation defined order, i.e. orders the referred types (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/types/type_info/operator_cmp&oldid=59494"